;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    FRQMETER.ASM                                      *
;    Dtum:         2000.11.12.                                       *
;    Verziszm:    V1.1                                              *
;    #3                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    FORDULATSZM/FREKVENCIAMR (TMR0, TMR1 DEMO) PROGRAM            *
;    -----------------------------------------------------            *
;    A Timer1 aszinkron mdban fut s 1msodpercenknt megszaktst   *
;    kr. A TMR1 modul sajt oszcilltort hasznlja, az idzt      *
;    elem az RC0 s az RC1 kivezetsek kz kapcsolt 32,768kHz-es     *
;    kvarc. A Timer0 az RA4 bemenetre rkez impulzusok lefut leit  *
;    szmolja. A szmllls eredmnye a Timer1 temezsvel a LED    *
;    soron jelenik meg, binris formban.                             *
;    A Timer0 elosztja 1/1, gy a max. bemen frekvencia 255Hz.     *
;    (Ez a frekvenciartk egy 4 tem, 4 hengeres motor esetn kb.   *
;    15000 percenknti fordulatszmnak felel meg.)                    *
;                                                                     *
;**********************************************************************
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;-------------------------------- PROGRAM START -------------------------------
;------------------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop			; MPLAB-ICD miatt szksges
		goto	Start
;------------------------------------------------------------------------------
;
;		
;------------------------------------------------------------------------------
;------------------------------- INTERRUPT RUTIN ------------------------------
;------------------------------------------------------------------------------
;
		org     4             	; IT vektor
		bcf	PIR1,TMR1IF	; Timer1 IT flag trls
		movf	TMR0,0		; ez kell majd
		movwf	PORTD
		clrf	TMR0
		movlw	H'80'		; Timer1=8000h bellts
		movwf	TMR1H		
		clrf	TMR1L		 
		retfie
;------------------------------------------------------------------------------
;
;
;------------------------------------------------------------------------------
;----------------------------------- FPROGRAM --------------------------------
;------------------------------------------------------------------------------
;
;
;------------------------------------------------------------------------------
; I/O portok konfigurlsa
;
Start		bsf	STATUS,RP0	
		bcf	STATUS,RP1	; bank1 kivlaszts
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'00111111'    	; RA0..RA5 bemenet
		movwf	TRISA
		movlw	B'11111111'	; PORTC bemenet, (default!)
		movwf	TRISC
		clrf	TRISD		; PORTD kimenet
;------------------------------------------------------------------------------
; Timer0 konfigurlsa
;
		movlw	B'11111111'	; default rtk: eloszt=1 s
		movwf	OPTION_REG	; TMR0 az RA4 lefut leit szmllja 
;------------------------------------------------------------------------------
; Timer1 konfigurlsa
;
		movlw	1		; TMR1IE=1
		movwf	PIE1		; Timer1 megszakts engedlyezs
		bcf	STATUS,RP0	; bank0 kivlaszts
		clrf	PORTD		; PORTD trls
		movlw	14		; Timer1 bellts: TMR1 oszc. eng.,
		movwf	T1CON		; eloszt=1, aszinkron md
		clrf	INTCON		; megszaktsok tiltsa
;------------------------------------------------------------------------------
		bcf	T1CON,TMR1ON	; Timer1 megllts
		bcf	PIR1,TMR1IF	; Timer1 IT flag trls
		movlw	H'80'		; Timer1=8000h bellts, 
		movwf	TMR1H		; gy 1 msodpercenknt kr megszaktst
		clrf	TMR1L		
		movlw	192		; GIE=1, PEIE=1
		movwf	INTCON		; Timer1 IT engedlyezs
		bsf	T1CON,TMR1ON	; Timer1 start
Loop		goto	Loop		; resetre vr
;------------------------------------------------------------------------------
		end               

