;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    LED.ASM                                           *
;    Dtum:         2000.11.09.                                       *
;    Verziszm:    V1.1                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    LED-sor vezrl program                                          *
;    -----------------------                                          *
;    A LED-soron 8 bites futfnyt valst meg.                       *
;    Az idzts a Timer3 segtsgvel, 20 ms lpsekben llthat.   *
;                                                                     *
;**********************************************************************
;
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;-----------------------------------------------------------
;
Timer1		equ	32
Timer2		equ	33
Timer3		equ	34
Pointer		equ	35
Counter		equ	36
;
;
;
;----------------------------------------------------------------------
;----------------------------- FPROGRAM ------------------------------
;----------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop
		bsf	STATUS,RP0	
		bcf	STATUS,RP1	; bank1 kivlaszts
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'00111111'    	; RA0..5 bemenet
		movwf	TRISA
		movlw	0		; D port kimenet
		movwf	TRISD
		bcf	STATUS,RP0	; bank0 kivlaszts
;----------------------------------------------------------------------
Start		movlw	33		; 33 elem a LED tblzat
		movwf	Counter
		clrf	Pointer
Start1		movf	Pointer,0
		call	Table0
		movwf	PORTD
		call	Delay
		incf	Pointer,1
		decfsz	Counter,1
		goto	Start1
;----------------------------------------------------------------------
		goto	Start
;----------------------------------------------------------------------
;
;
;----------------------------------------------------------------------
;---------------------------- SZUBRUTINOK -----------------------------
;----------------------------------------------------------------------
;
Table0		addwf	PCL,1
		retlw	B'10000001'	; '0'
		retlw	B'01000010'	; '1'
		retlw	B'00100100'	; '2'
		retlw	B'00011000'	; '3'
		retlw	B'00100100'	; '4'
		retlw	B'01000010'	; '5'
		retlw	B'10000001'	; '6'
		retlw	B'01000001'	; '7'
		retlw	B'00100001'	; '8'
		retlw	B'00010001'	; '9'
		retlw	B'00001001'	; '10'
		retlw	B'00000101'	; '11'
		retlw	B'00000011'	; '12'
		retlw	B'00000001'	; '13'
		retlw	B'00000011'	; '14'
		retlw	B'00000101'	; '15'
		retlw	B'00001001'	; '16'
		retlw	B'00010001'	; '17'
		retlw	B'00100001'	; '18'
		retlw	B'01000001'	; '19'
		retlw	B'10000010'	; '20'
		retlw	B'10000100'	; '21'
		retlw	B'10001000'	; '22'
		retlw	B'10010000'	; '23'
		retlw	B'10100000'	; '24'
		retlw	B'11000000'	; '25'
		retlw	B'10000000'	; '26'
		retlw	B'11000000'	; '27'
		retlw	B'10100000'	; '28'
		retlw	B'10010000'	; '29'
		retlw	B'10001000'	; '30'
		retlw	B'10000100'	; '31'
		retlw	B'10000010'	; '32'
;----------------------------------------------------------------------
Delay		movlw	10		; Timer3 x 20 ms
		movwf	Timer3
Delay0		call	Delay1
		decfsz	Timer3,1	
		goto	Delay0
		return
;----------------------------------------------------------------------
Delay1		movlw	130		; kb. 20 ms
		movwf	Timer2
Delay2		decfsz	Timer1,1	
		goto	Delay2
		decfsz	Timer2,1	
		goto	Delay2
		return
;----------------------------------------------------------------------
		end

