;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    POTM.ASM                                          *
;    Dtum:         2000.11.10.                                       *
;    Verziszm:    V1.1                                              *
;    #1                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    LED SOR KEZEL PROGRAM                                           *
;    ----------------------                                           *
;    Az A/D konverzi eredmnyt a LED soron jelenti meg.            *
;    A mintavtel gyakorisgt a TMR0 tlcsordulsa hatrozza meg.    *
;                                                                     *
;**********************************************************************
;
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;------------------------------------------------------------------------------
;
DlyCntr		equ	32
OvfCntr		equ	33
Mutato		equ	35
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM ------------------------------
;------------------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop
		bcf	STATUS,RP0	; bank0 kivlaszts
		bcf	STATUS,RP1
		movlw	B'11000001'	; RC oszcilltor, A/D engedlyezs
		movwf	ADCON0		; 0. csatorna (RA0) kivlaszts
		bsf	STATUS,RP0	; bank1 kivlaszts
		movlw	B'10000111'	; TMR0 eloszt= 1:256
		movwf	OPTION_REG
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'11111111'    	; PORTA bemenet
		movwf	TRISA
		clrf	TRISD		; PORTD kimenet
		bcf	STATUS,RP0	; bank0 kivlaszts
		clrf	PORTD
		movlw	10		; TMR0 tlcsorduls szmll kezdeti
		movwf	OvfCntr		; rtke 10
;------------------------------------------------------------------------------
; A TMR0 tlcsorduls nem okoz megszaktst, (hiszen azt nem is engedlyeztk)
; de bekvetkeztt a T0IF flag vizsglatval figyeljk.
; A/D konverzit minden 10. TMR0 tlcsordulsra vgznk.
;
Start		btfss	INTCON,T0IF	; TMR0 tlcsorduls volt?
		goto	Start		; mg nem
;------------------------------------------------------------------------------
		bcf	INTCON,T0IF	; igen, flag trls
		decfsz	OvfCntr,1	; tlcsorduls szmll dekrementlsa
		goto	Start		; mg nem 0
;------------------------------------------------------------------------------
		movlw	10		; mintavtel 10 tlcsordulsonknt
		movwf	OvfCntr		; szmll visszallts
		bcf	INTCON,T0IF	; igen, flag trls
		bsf	ADCON0,GO	; A/D konverzi start
Wait		btfss	PIR1,ADIF	; vrakozs a teljes konverzira
	        goto	Wait
;------------------------------------------------------------------------------
		movf	ADRESH,0	; ADRESH tartalmnak kijelzse
		movwf	PORTD		; a LED soron
		goto	Start
;------------------------------------------------------------------------------
		end      
		
		

