;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    POTM1.ASM                                         *
;    Dtum:         2000.11.10.                                       *
;    Verziszm:    V1.1                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    LED SOR KEZEL PROGRAM                                           *
;    ----------------------                                           *
;    A LED-soron 8 bites futfnyt valst meg.                       *
;    A sebessget a potencimter llsa hatrozza meg.               *
;    A program TMR0 megszaktst hasznl.                             *
;                                                                     *
;**********************************************************************
;
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;----------------------------------------------------------------------
;
Timer1		equ	32
Timer2		equ	33
Timer3		equ	34
Pointer		equ	35
Counter		equ	36
Temp		equ	37
IT_Counter	equ	38
W_Temp		equ	39
Status_Temp	equ	40
AD_Result	equ	41
;
;
;
;----------------------------------------------------------------------
;----------------------------- FPROGRAM ------------------------------
;----------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop
		goto	Start
;----------------------------------------------------------------------
;
;----------------------------------------------------------------------
; A szubrutin TMR0 tlcsordulskor hajtdik vgre. A szubrutin elmenti a 
; W s a STATUS regiszterek pillanatnyi llapott az aktulis bankba,
; visszatrskor pedig visszalltja azok elmentett rtkt.
; Minden 10. megszakts utn vgznk A/D konverzit.
;
		org     4             	; IT vektor
		bcf     INTCON,T0IF
		movwf	W_Temp	        ; W ments
		swapf	STATUS,0
		movwf	Status_Temp     ; Status regiszter ments
		decfsz	IT_Counter,1	; szmll dekrementlsa 
		goto	Subend		; mg nem 0
;----------------------------------------------------------------------
		movlw	10		; szmll visszallts
		movwf	IT_Counter	
		bsf	ADCON0,GO	; A/D konverzi indul
Wait		btfss	PIR1,ADIF	; vrakozs a teljes konverzira
	        goto	Wait
;----------------------------------------------------------------------
		movf	ADRESH,0	; A/D konverzi eredmnynek msolsa
		movwf	AD_Result
		btfsc	STATUS,Z	; ha az eredmny 0, hozzadunk 1-et
		incf	AD_Result,1	; (ksleltets= A/D eredmny x 5ms)
Subend		swapf	Status_Temp,0
		movwf	STATUS		; Status regiszter visszallts 
		swapf	W_Temp,1
		swapf	W_Temp,0	; W visszallts
		retfie
;----------------------------------------------------------------------
;
;
;
;----------------------------------------------------------------------
Start		bcf	STATUS,RP0	
		bcf	STATUS,RP1	; bank0 kivlaszts
		movlw	B'11000001'	; RC oszcilltor, A/D engedlyezs
		movwf	ADCON0		; eredmny balra igaztsa
		clrf	PORTD		; 
		bsf	STATUS,RP0	; bank1 kivlaszts
		movlw	135		; TMR0 eloszt= 1:256
		movwf	OPTION_REG
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'11111111'    	; PORTA bemenet
		movwf	TRISA
		clrf	TRISD		; PORTD kimenet
		bcf	STATUS,RP0	; bank0 kivlaszts
		movlw	10
		movwf	IT_Counter	; megszakts szmll bellts
		movlw	160
		movwf	INTCON		; TMR0 megszakts engedlyezs
;----------------------------------------------------------------------
Loop		movlw	14		; kijelzend llapotok szma
		movwf	Counter
		clrf	Pointer		; mutat trls
Loop1		movf	Pointer,0	; mutat bemsolsa W regiszterbe
		call	Table0		; mutatnak megfelel rtkkel tr 
		movwf	PORTD		; vissza W-ben, mely a LED sorra kerl
		call	Delay		; ksleltets, mely "potmter fgg"
		incf	Pointer,1	; mutat inkrementls
		decfsz	Counter,1	; ciklus szmll dekrementls
		goto	Loop1		; mg nem 0
;----------------------------------------------------------------------
		goto	Loop		; elrte 0-t, kezdeti llapot bellts
;----------------------------------------------------------------------
;
;
;----------------------------------------------------------------------
;---------------------------- SZUBRUTINOK -----------------------------
;----------------------------------------------------------------------
; A tblzatba W=Pointer rtkkel lpnk be, s W-ben a Pointer-nek megfelel
; rtkkel lpnk ki.
;
Table0		addwf	PCL,1
		retlw	B'10000000'	; W=0
		retlw	B'01000000'	; W=1 
		retlw	B'00100000'	; W=2
		retlw	B'00010000'	; W=3
		retlw	B'00001000'	; W=4
		retlw	B'00000100'	; W=5
		retlw	B'00000010'	; W=6
		retlw	B'00000001'	; W=7
		retlw	B'00000010'	; W=8
		retlw	B'00000100'	; W=9
		retlw	B'00001000'	; W=10
		retlw	B'00010000'	; W=11
		retlw	B'00100000'	; W=12
		retlw	B'01000000'	; W=13
;----------------------------------------------------------------------
Delay		movf	AD_Result,0	; eredmny a Timer3 regiszterbe
		movwf	Timer3	
Delay0		call	Delay1		; ksleltets = Timer3 x 5 ms
		decfsz	Timer3,1	
		goto	Delay0
		return
;----------------------------------------------------------------------
Delay1		movlw	32		; kb. 5 ms ksleltets
		movwf	Timer2
Delay2		decfsz	Timer1,1	
		goto	Delay2
		decfsz	Timer2,1	
		goto	Delay2
		return
;----------------------------------------------------------------------
		end

