;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    TIMER1.ASM                                        *
;    Dtum:         2000.11.12.                                       *
;    Verziszm:    V1.1                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    TMR1 DEMO PROGRAM                                                *
;    -----------------                                                *
;    "Vals idej ra" alkalmazs.                                    *
;    A Timer1 aszinkron mdban fut s 0,5 mp-knt megszaktst kr.   *
;    A TMR1 modul sajt oszcilltort hasznlja, az idzt elem az   *
;    RC0 s RC1 kivezetsek kz kapcsolt 32,768kHz-es kvarc.         *
;    1 mp idztssel villogtatja a LED-eket. (kitltsi tnyez=50%) *
;                                                                     *
;**********************************************************************
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM ------------------------------
;------------------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop			; MPLAB-ICD miatt szksges
		goto	Start
;------------------------------------------------------------------------------
		
		org     4             	; IT vektor
		bcf	PIR1,TMR1IF	; Timer1 IT flag trls
		movlw	B'11111111'
		xorwf	PORTD,1
		movlw	H'C0'		; Timer1=C000h bellts
		movwf	TMR1H		
		clrf	TMR1L		 
		retfie
;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
; I/O portok konfigurlsa
;
Start		bsf	STATUS,RP0	
		bcf	STATUS,RP1	; bank1 kivlaszts
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'00100001'    	; RA0, RA5 bemenet, RA1..4 kimenet
		movwf	TRISA
		movlw	B'11111111'	; PORTC bemenet, (default!)
		movwf	TRISC
		clrf	TRISD		; PORTD kimenet
;------------------------------------------------------------------------------
; Timer1 konfigurlsa
;
		movlw	1		; TMR1IE=1
		movwf	PIE1		; Timer1 megszakts engedlyezs
		bcf	STATUS,RP0	; bank0 kivlaszts
		movlw	14		; Timer1 bellts: TMR1 oszc. eng.,
		movwf	T1CON		; eloszt=1, aszinkron md
		clrf	INTCON		; megszaktsok tiltsa
;------------------------------------------------------------------------------
		bcf	T1CON,TMR1ON	; Timer1 megllts
		bcf	PIR1,TMR1IF	; Timer1 IT flag trls
		movlw	H'C0'		; Timer1=C000h bellts, 
		movwf	TMR1H		; gy 0,5 mp-knt kr megszaktst
		clrf	TMR1L		
		movlw	192		; GIE=1, PEIE=1
		movwf	INTCON		; Timer1 IT engedlyezs
		bsf	T1CON,TMR1ON	; Timer1 start
		clrf	PORTD
Loop		goto	Loop		; resetre vr
;------------------------------------------------------------------------------
		end               

