;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    TMR1WU.ASM                                        *
;    Dtum:         2000.11.15.                                       *
;    Verziszm:    V1.1                                              *
;    #2                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    BRESZTS TMR1 TLCSORDULSRA (DEMO PROGRAM)                     *
;    --------------------------------------------                     *
;    A Timer1 aszinkron mdban fut s 4 mp-knt megszaktst kr.     *
;    4 mp idztssel villogtatja a LED-eket.                         *
;                                                                     *
;**********************************************************************
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_ON & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM -------------------------------
;------------------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop			; MPLAB-ICD miatt szksges
;------------------------------------------------------------------------------
; I/O portok konfigurlsa
;
		bsf	STATUS,RP0	
		bcf	STATUS,RP1	; bank1 kivlaszts
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'11111111'
		movwf	TRISA    	; PORTA bemenet, (default!)
		movwf	TRISC		; PORTC bemenet, (default!)
		clrf	TRISD		; PORTD kimenet
		movlw	1
		movwf	PIE1		; TMR1 megszakts engedlyezs
		bcf	STATUS,RP0	; bank0 kivlaszts
		movlw	0x55
		movwf	PORTD
;------------------------------------------------------------------------------
; TIMER1 idzt konfigurlsa
;
		movlw	B'00011110'	; Timer1 bellts: TMR1 oszc. eng.,
		movwf	T1CON		; eloszt= 1:2, aszinkron md
		clrf	INTCON		; megszaktsok tiltsa
;		bcf	T1CON,TMR1ON	; Timer1 megllts
		bcf	PIR1,TMR1IF	; Timer1 IT flag trls
		clrf	TMR1H		; Timer1 trls, gy 4 mp mlva breszt
		clrf	TMR1L		; 
		movlw	64		; PEIE=1
		movwf	INTCON		; Timer1 IT engedlyezs
		bsf	T1CON,TMR1ON	; Timer1 start
;------------------------------------------------------------------------------
Loop		sleep
		nop
		nop			; breds SLEEP-bl 
		bcf	PIR1,TMR1IF	; Timer1 IT flag trls
		movlw	B'11111111'
		xorwf	PORTD,1		; ellenkez LED-ek vilgtanak
		goto	Loop		; vissza SLEEP-be
;------------------------------------------------------------------------------
		end               

