;
;**********************************************************************
;                                                                     *
;    FD-1 FLASH DEMO PRBAPANEL PROJEKT                               *
;                                                                     *
;**********************************************************************
;                                                                     *
;    Fjlnv:	    WAKEUP.ASM                                        *
;    Dtum:         2000.11.15.                                       *
;    Verziszm:    V1.2                                              *
;    #5                                                               *
;                                                                     *
;    Szerz:        Szeg Jnos                                       *
;    Cg neve:      jpesti Mszaki Szakkzpiskola                   *
;    E-mail:	    szego@umszki.hu                                   *
;                                                                     * 
;**********************************************************************
;                                                                     *
;    BRESZTS PORTB JELSZINT VLTOZSRA                              *
;    -----------------------------------                              *
;    1/ SLEEP llapotban csak az RD0 kivezetsre kttt LED vilgt,  *
;       breszts utn mindegyik.                                     *
;    2/ Csak az RB0-ra kttt K0 s K1 gombok bresztenek.            *
;    3/ Fordtott port konfigurls esetn RB0 megszakts is         *
;       bresztheti a mikrovezrlt!                                  *
;                                                                     *
;**********************************************************************
;
;
	list      p=16F877            
	#include <p16F877.inc>         
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _LVP_OFF
;------------------------------------------------------------------------------
;
;
;
;------------------------------------------------------------------------------
;------------------------------------- FPROGRAM ------------------------------
;------------------------------------------------------------------------------
;
		org     0             	; reset vektor
		nop
;-------------------------------------------------------------------------------
; PORTA, PORTB, PORTD konfigurlsa
;
		bcf	STATUS,RP0	
		bsf	STATUS,RP0	; bank1 kivlaszts
		movlw	14
		movwf	ADCON1		; RA0 analg bemenet !!!
		movlw	B'00111111'    	; PORTA bemenet
		movwf	TRISA
		movlw	B'11110000'    	; RB0..3 kimenet, RB4..7 bemenet
		movwf	TRISB
		clrf	TRISD		; PORTD kimenet
		bcf	OPTION_REG,NOT_RBPU	; felhz ellenllsok konfigurlsa
		bcf	STATUS,RP0	; bank0 kivlaszts
;------------------------------------------------------------------------------
Start		call	InitRB
		movlw	B'00000001'
		movwf	PORTD
		sleep
		nop
		movlw	B'11111111'
		movwf	PORTD
Stop		goto	Stop
;------------------------------------------------------------------------------
		goto	Start
;
;
;------------------------------------------------------------------------------
;------------------------------------ SZUBRUTINOK -----------------------------
;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
; Elkszts a PORTB szintltozs megszaktsra.
;
InitRB		movlw	B'11111110'
		movwf	PORTB
		bcf     INTCON,RBIE	; PORTB megszakts tiltsa
                movf    PORTB,0		; PORTB beolvass (s trols)
                bcf     INTCON,RBIF	; megszakts flag trls
                bsf     INTCON,RBIE	; PORTB szintvltozs IT engedlyezs
		return
;------------------------------------------------------------------------------
		end                   	










